<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::NcpFrameBuffer Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/d78/classThread_1_1NcpFrameBuffer.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../d4/dab/classThread_1_1NcpFrameBuffer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::NcpFrameBuffer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a0ee345fdaf05d9e00da8a2f9bf628824"><td class="memItemLeft" align="right" valign="top">typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>) (void *aContext, <a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a> *aNcpFrameBuffer)</td></tr>
<tr class="memdesc:a0ee345fdaf05d9e00da8a2f9bf628824"><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines a function pointer callback which is invoked to inform state transition of buffer, going from empty to non-empty or becoming empty.  <a href="#a0ee345fdaf05d9e00da8a2f9bf628824">More...</a><br /></td></tr>
<tr class="separator:a0ee345fdaf05d9e00da8a2f9bf628824"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad20ceecdfd9130815f4f59a9192afeeb"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb">NcpFrameBuffer</a> (uint8_t *aBuffer, uint16_t aBufferLength)</td></tr>
<tr class="memdesc:ad20ceecdfd9130815f4f59a9192afeeb"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor creates an NCP frame buffer.  <a href="#ad20ceecdfd9130815f4f59a9192afeeb">More...</a><br /></td></tr>
<tr class="separator:ad20ceecdfd9130815f4f59a9192afeeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae80bc3d36fafc2a41b13270f7ffe54c2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2">~NcpFrameBuffer</a> ()</td></tr>
<tr class="memdesc:ae80bc3d36fafc2a41b13270f7ffe54c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">This destructor clears the NCP frame buffer and clears all frames.  <a href="#ae80bc3d36fafc2a41b13270f7ffe54c2">More...</a><br /></td></tr>
<tr class="separator:ae80bc3d36fafc2a41b13270f7ffe54c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2380a440712abb615835172a0863bdf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf">Clear</a> (void)</td></tr>
<tr class="memdesc:ab2380a440712abb615835172a0863bdf"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method clears the NCP frame buffer.  <a href="#ab2380a440712abb615835172a0863bdf">More...</a><br /></td></tr>
<tr class="separator:ab2380a440712abb615835172a0863bdf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69de51cb5b7132fa7d82270f3090f4dc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a69de51cb5b7132fa7d82270f3090f4dc">SetCallbacks</a> (<a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a> aEmptyBufferCallback, <a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a> aNonEmptyBufferCallback, void *aContext)</td></tr>
<tr class="memdesc:a69de51cb5b7132fa7d82270f3090f4dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sets the callbacks and context.  <a href="#a69de51cb5b7132fa7d82270f3090f4dc">More...</a><br /></td></tr>
<tr class="separator:a69de51cb5b7132fa7d82270f3090f4dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f8aef01dd5f6b673c2a16a7e0aece29"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a5f8aef01dd5f6b673c2a16a7e0aece29">InFrameBegin</a> (void)</td></tr>
<tr class="memdesc:a5f8aef01dd5f6b673c2a16a7e0aece29"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method begins a new input frame to be added/written to the frame buffer.  <a href="#a5f8aef01dd5f6b673c2a16a7e0aece29">More...</a><br /></td></tr>
<tr class="separator:a5f8aef01dd5f6b673c2a16a7e0aece29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3987c8813a4aa3f7874b920736390e97"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a3987c8813a4aa3f7874b920736390e97">InFrameFeedData</a> (const uint8_t *aDataBuffer, uint16_t aDataBufferLength)</td></tr>
<tr class="memdesc:a3987c8813a4aa3f7874b920736390e97"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method adds data to the current input frame being written to the buffer.  <a href="#a3987c8813a4aa3f7874b920736390e97">More...</a><br /></td></tr>
<tr class="separator:a3987c8813a4aa3f7874b920736390e97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5fa8d69618ffb232ea0693f5622e948"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af5fa8d69618ffb232ea0693f5622e948">InFrameFeedMessage</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage)</td></tr>
<tr class="memdesc:af5fa8d69618ffb232ea0693f5622e948"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method adds a message to the current input frame being written to the buffer.  <a href="#af5fa8d69618ffb232ea0693f5622e948">More...</a><br /></td></tr>
<tr class="separator:af5fa8d69618ffb232ea0693f5622e948"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46d59d1e7c71eff0d4cf9ea91b821ead"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a46d59d1e7c71eff0d4cf9ea91b821ead">InFrameEnd</a> (void)</td></tr>
<tr class="memdesc:a46d59d1e7c71eff0d4cf9ea91b821ead"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method finalizes/ends the current input frame being written to the buffer.  <a href="#a46d59d1e7c71eff0d4cf9ea91b821ead">More...</a><br /></td></tr>
<tr class="separator:a46d59d1e7c71eff0d4cf9ea91b821ead"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34a6141ff650ec07602b246fe3e65404"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404">IsEmpty</a> (void) const </td></tr>
<tr class="memdesc:a34a6141ff650ec07602b246fe3e65404"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method checks if the buffer is empty.  <a href="#a34a6141ff650ec07602b246fe3e65404">More...</a><br /></td></tr>
<tr class="separator:a34a6141ff650ec07602b246fe3e65404"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7e6c123cca21c4ea9459c2a3ca350b6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af7e6c123cca21c4ea9459c2a3ca350b6">OutFrameBegin</a> (void)</td></tr>
<tr class="memdesc:af7e6c123cca21c4ea9459c2a3ca350b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method begins/prepares a new output frame to be read from the frame buffer.  <a href="#af7e6c123cca21c4ea9459c2a3ca350b6">More...</a><br /></td></tr>
<tr class="separator:af7e6c123cca21c4ea9459c2a3ca350b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf94a643cd4931c947e4682c6fa21a64"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#abf94a643cd4931c947e4682c6fa21a64">OutFrameHasEnded</a> (void)</td></tr>
<tr class="memdesc:abf94a643cd4931c947e4682c6fa21a64"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method checks if the current output frame (being read) has ended.  <a href="#abf94a643cd4931c947e4682c6fa21a64">More...</a><br /></td></tr>
<tr class="separator:abf94a643cd4931c947e4682c6fa21a64"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8004f00f97e629cf5c5b0c6d695fcdc"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af8004f00f97e629cf5c5b0c6d695fcdc">OutFrameReadByte</a> (void)</td></tr>
<tr class="memdesc:af8004f00f97e629cf5c5b0c6d695fcdc"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method reads and returns the next byte from the current output frame.  <a href="#af8004f00f97e629cf5c5b0c6d695fcdc">More...</a><br /></td></tr>
<tr class="separator:af8004f00f97e629cf5c5b0c6d695fcdc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4062341057541242068c5680c35f5a1c"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a4062341057541242068c5680c35f5a1c">OutFrameRead</a> (uint16_t aReadLength, uint8_t *aDataBuffer)</td></tr>
<tr class="memdesc:a4062341057541242068c5680c35f5a1c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method reads bytes from the current output frame.  <a href="#a4062341057541242068c5680c35f5a1c">More...</a><br /></td></tr>
<tr class="separator:a4062341057541242068c5680c35f5a1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8a97ac52ae66b96155e6fb72cbd7e38"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab8a97ac52ae66b96155e6fb72cbd7e38">OutFrameRemove</a> (void)</td></tr>
<tr class="memdesc:ab8a97ac52ae66b96155e6fb72cbd7e38"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method removes the current/front output frame from the buffer.  <a href="#ab8a97ac52ae66b96155e6fb72cbd7e38">More...</a><br /></td></tr>
<tr class="separator:ab8a97ac52ae66b96155e6fb72cbd7e38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b7c96ec541408d307edf2c069ef208c"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a8b7c96ec541408d307edf2c069ef208c">OutFrameGetLength</a> (void)</td></tr>
<tr class="memdesc:a8b7c96ec541408d307edf2c069ef208c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method returns the number of bytes (length) of current/front frame in the NCP frame buffer.  <a href="#a8b7c96ec541408d307edf2c069ef208c">More...</a><br /></td></tr>
<tr class="separator:a8b7c96ec541408d307edf2c069ef208c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a class="anchor" id="a0ee345fdaf05d9e00da8a2f9bf628824"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(* Thread::NcpFrameBuffer::BufferCallback) (void *aContext, <a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a> *aNcpFrameBuffer)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Defines a function pointer callback which is invoked to inform state transition of buffer, going from empty to non-empty or becoming empty. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to arbitrary context information. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aNcpFrameBuffer</td><td>A pointer to the <a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad20ceecdfd9130815f4f59a9192afeeb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::NcpFrameBuffer::NcpFrameBuffer </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>aBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aBufferLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor creates an NCP frame buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuffer</td><td>A pointer to a buffer which will be used by NCP frame buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aBufferLength</td><td>The buffer size (in bytes). </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ad20ceecdfd9130815f4f59a9192afeeb_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ad20ceecdfd9130815f4f59a9192afeeb_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ad20ceecdfd9130815f4f59a9192afeeb_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ad20ceecdfd9130815f4f59a9192afeeb_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a69de51cb5b7132fa7d82270f3090f4dc" title="This method sets the callbacks and context. " alt="" coords="222,211,390,249"/>
<area shape="rect" id="node6" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf" title="This method clears the NCP frame buffer. " alt="" coords="222,148,390,187"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="663,104,828,143"/>
<area shape="rect" id="node4" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="440,211,605,249"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="443,161,603,187"/>
<area shape="rect" id="node7" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="438,47,607,85"/>
<area shape="rect" id="node8" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="655,5,836,31"/>
<area shape="rect" id="node9" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="664,55,828,80"/>
<area shape="rect" id="node10" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="884,55,1082,80"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ae80bc3d36fafc2a41b13270f7ffe54c2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::NcpFrameBuffer::~NcpFrameBuffer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This destructor clears the NCP frame buffer and clears all frames. </p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ae80bc3d36fafc2a41b13270f7ffe54c2_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ae80bc3d36fafc2a41b13270f7ffe54c2_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ae80bc3d36fafc2a41b13270f7ffe54c2_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ae80bc3d36fafc2a41b13270f7ffe54c2_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a69de51cb5b7132fa7d82270f3090f4dc" title="This method sets the callbacks and context. " alt="" coords="222,211,390,249"/>
<area shape="rect" id="node6" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf" title="This method clears the NCP frame buffer. " alt="" coords="222,148,390,187"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="663,104,828,143"/>
<area shape="rect" id="node4" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="440,211,605,249"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="443,161,603,187"/>
<area shape="rect" id="node7" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="438,47,607,85"/>
<area shape="rect" id="node8" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="655,5,836,31"/>
<area shape="rect" id="node9" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="664,55,828,80"/>
<area shape="rect" id="node10" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="884,55,1082,80"/>
</map>
</div>
</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ab2380a440712abb615835172a0863bdf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::NcpFrameBuffer::Clear </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method clears the NCP frame buffer. </p>
<p>All the frames are cleared/removed.</p>
<dl class="section return"><dt>Returns</dt><dd>Nothing (void). </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="222,61,390,100"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="447,5,612,44"/>
<area shape="rect" id="node7" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="224,124,389,163"/>
<area shape="rect" id="node8" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="226,187,386,212"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="438,68,620,93"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="447,117,611,143"/>
<area shape="rect" id="node6" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="668,117,866,143"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ab2380a440712abb615835172a0863bdf_icgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb" title="This constructor creates an NCP frame buffer. " alt="" coords="222,5,390,44"/>
<area shape="rect" id="node3" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2" title="This destructor clears the NCP frame buffer and clears all frames. " alt="" coords="222,68,390,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a5f8aef01dd5f6b673c2a16a7e0aece29"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::InFrameBegin </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method begins a new input frame to be added/written to the frame buffer. </p>
<p>If there is a previous frame being written (<code><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a46d59d1e7c71eff0d4cf9ea91b821ead" title="This method finalizes/ends the current input frame being written to the buffer. ">InFrameEnd()</a></code> has not yet been called on the frame), this method will discard and clear the previous unfinished frame.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully started a new frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to start a new frame. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a5f8aef01dd5f6b673c2a16a7e0aece29_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a5f8aef01dd5f6b673c2a16a7e0aece29_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a5f8aef01dd5f6b673c2a16a7e0aece29_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a5f8aef01dd5f6b673c2a16a7e0aece29_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#a114f7f0fc7acef21a0c20c6b3910babb" title="This method is called to start a new outbound frame. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a31f1b8b217246e7dcdf0ee2b4e025b83" title="This method is called to start a new outbound frame. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a46d59d1e7c71eff0d4cf9ea91b821ead"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::InFrameEnd </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method finalizes/ends the current input frame being written to the buffer. </p>
<p>If no buffer space is available, this method will discard and clear the frame before returning an error status.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added the message to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add message. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="222,61,390,100"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="447,5,612,44"/>
<area shape="rect" id="node7" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="224,124,389,163"/>
<area shape="rect" id="node8" href="../../da/d1a/classThread_1_1MessageQueue.html#a5e6f37c86a48e8dfbfcc7a7c14c23808" title="This method adds a message to the end of the list. " alt="" coords="224,187,389,225"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="438,68,620,93"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="447,117,611,143"/>
<area shape="rect" id="node6" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="668,117,866,143"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a46d59d1e7c71eff0d4cf9ea91b821ead_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a3987c8813a4aa3f7874b920736390e97"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::InFrameFeedData </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aDataBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aDataBufferLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method adds data to the current input frame being written to the buffer. </p>
<p>If no buffer space is available, this method will discard and clear the frame before returning an error status.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aDataBuffer</td><td>A pointer to data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aDataBufferLength</td><td>The length of the data buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added new data to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add data. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a3987c8813a4aa3f7874b920736390e97_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a3987c8813a4aa3f7874b920736390e97_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a3987c8813a4aa3f7874b920736390e97_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a3987c8813a4aa3f7874b920736390e97_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#a636c968d8cce6cbf116c1bf22fb72ecd" title="This method adds data to the current outbound frame being written. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#ab5f242e8e3925bbc1cce59f12b5207c3" title="This method adds data to the current outbound frame being written. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="af5fa8d69618ffb232ea0693f5622e948"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::InFrameFeedMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method adds a message to the current input frame being written to the buffer. </p>
<p>If no buffer space is available, this method will discard and clear the frame before returning an error status. In case of success, the passed-in message <code>aMessage</code> will be owned by the frame buffer instance and will be freed when either the the frame is removed or discarded.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the message to be added to current frame.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added the message to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add message. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_cgraph">
<area shape="rect" id="node2" href="../../da/d1a/classThread_1_1MessageQueue.html#a5e6f37c86a48e8dfbfcc7a7c14c23808" title="This method adds a message to the end of the list. " alt="" coords="222,5,387,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_af5fa8d69618ffb232ea0693f5622e948_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#a9614ae49bf12256c3b0086c55a877142" title="This method adds a message to the current outbound frame being written. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a7e2aed732161d738b481849ff1dad610" title="This method adds a message to the current outbound frame being written. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a34a6141ff650ec07602b246fe3e65404"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Thread::NcpFrameBuffer::IsEmpty </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method checks if the buffer is empty. </p>
<p>An non-empty buffer contains at least one full frame for reading.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td><a class="el" href="../../db/d50/classThread_1_1Buffer.html" title="This class represents a Message buffer. ">Buffer</a> is not empty and contains at least one full frame for reading. </td></tr>
    <tr><td class="paramname">false</td><td><a class="el" href="../../db/d50/classThread_1_1Buffer.html" title="This class represents a Message buffer. ">Buffer</a> is empty and contains no frame for reading. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_cgraph">
<area shape="rect" id="node2" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="230,5,395,44"/>
<area shape="rect" id="node3" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="222,68,403,93"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="230,117,395,143"/>
<area shape="rect" id="node5" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="451,117,649,143"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a34a6141ff650ec07602b246fe3e65404_icgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf" title="This method clears the NCP frame buffer. " alt="" coords="222,36,390,75"/>
<area shape="rect" id="node5" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a46d59d1e7c71eff0d4cf9ea91b821ead" title="This method finalizes/ends the current input frame being written to the buffer. " alt="" coords="222,213,390,252"/>
<area shape="rect" id="node6" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="441,183,621,221"/>
<area shape="rect" id="node7" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="438,276,624,315"/>
<area shape="rect" id="node8" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab8a97ac52ae66b96155e6fb72cbd7e38" title="This method removes the current/front output frame from the buffer. " alt="" coords="222,276,390,315"/>
<area shape="rect" id="node9" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a8b7c96ec541408d307edf2c069ef208c" title="This method returns the number of bytes (length) of current/front frame in the NCP frame buffer..." alt="" coords="222,151,390,189"/>
<area shape="rect" id="node3" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb" title="This constructor creates an NCP frame buffer. " alt="" coords="447,5,616,44"/>
<area shape="rect" id="node4" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2" title="This destructor clears the NCP frame buffer and clears all frames. " alt="" coords="447,68,616,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="af7e6c123cca21c4ea9459c2a3ca350b6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::OutFrameBegin </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method begins/prepares a new output frame to be read from the frame buffer. </p>
<p>The NCP buffer maintains a read offset for the current frame being read. Before reading any bytes from the frame this method should be called to prepare the frame and set the read offset.</p>
<p>If part of current frame has already been read, a sub-sequent call to this method will reset the read offset back to beginning of current output frame.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully started/prepared a new output frame for reading. </td></tr>
    <tr><td class="paramname">kThreadError_NotFound</td><td>No frame available in buffer for reading. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_af7e6c123cca21c4ea9459c2a3ca350b6_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_af7e6c123cca21c4ea9459c2a3ca350b6_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_af7e6c123cca21c4ea9459c2a3ca350b6_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_af7e6c123cca21c4ea9459c2a3ca350b6_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a8b7c96ec541408d307edf2c069ef208c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t Thread::NcpFrameBuffer::OutFrameGetLength </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method returns the number of bytes (length) of current/front frame in the NCP frame buffer. </p>
<p>The NCP buffer stores the frames in FIFO order. This method returns the length of the front frame (which may be the current output frame being read) from the buffer. There is no need to prepare/begin reading the current frame before calling this method so this method can be used without a previous call to <code><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af7e6c123cca21c4ea9459c2a3ca350b6" title="This method begins/prepares a new output frame to be read from the frame buffer. ">OutFrameBegin()</a></code>.</p>
<p>If there is no frame in buffer, this method returns zero.</p>
<dl class="section return"><dt>Returns</dt><dd>The number of bytes (length) of current/front frame, or zero if no frame in buffer. </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="235,61,404,100"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="473,5,638,44"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="465,121,646,147"/>
<area shape="rect" id="node7" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="222,176,417,201"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="473,68,638,93"/>
<area shape="rect" id="node6" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="694,68,892,93"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a8b7c96ec541408d307edf2c069ef208c_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,5,402,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="abf94a643cd4931c947e4682c6fa21a64"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Thread::NcpFrameBuffer::OutFrameHasEnded </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method checks if the current output frame (being read) has ended. </p>
<p>The NCP buffer maintains a read offset for the current output frame being read. This method returns true if the read offset is at the end of the frame and there are no more bytes available to read from current frame.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>Frame has ended (no more bytes available to read from current output frame). </td></tr>
    <tr><td class="paramname">false</td><td>Frame has data (can read more bytes from current output frame). </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_abf94a643cd4931c947e4682c6fa21a64_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_abf94a643cd4931c947e4682c6fa21a64_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_abf94a643cd4931c947e4682c6fa21a64_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_abf94a643cd4931c947e4682c6fa21a64_icgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a4062341057541242068c5680c35f5a1c" title="This method reads bytes from the current output frame. " alt="" coords="231,5,399,44"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,68,408,107"/>
<area shape="rect" id="node3" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="456,5,636,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a4062341057541242068c5680c35f5a1c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t Thread::NcpFrameBuffer::OutFrameRead </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aReadLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>aDataBuffer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method reads bytes from the current output frame. </p>
<p>The NCP buffer maintains a read offset for the current output frame being read. This method attempts to read the given number of bytes (<code>aDataBufferLength</code>) from the current frame and copies the bytes into the given data buffer (<code>aDataBuffer</code>). It also moves the read offset forward accordingly. If there are less bytes remaining in current frame, the available bytes are read/copied. This methods returns the actual number of bytes read.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aDataBuffer</td><td>A pointer to a data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aReadLength</td><td>Number of bytes to read.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of bytes read and copied into data buffer. </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#abf94a643cd4931c947e4682c6fa21a64" title="This method checks if the current output frame (being read) has ended. " alt="" coords="222,5,390,44"/>
<area shape="rect" id="node3" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af8004f00f97e629cf5c5b0c6d695fcdc" title="This method reads and returns the next byte from the current output frame. " alt="" coords="222,68,390,107"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a4062341057541242068c5680c35f5a1c_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,5,402,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="af8004f00f97e629cf5c5b0c6d695fcdc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t Thread::NcpFrameBuffer::OutFrameReadByte </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method reads and returns the next byte from the current output frame. </p>
<p>The NCP buffer maintains a read offset for the current output frame being read. This method reads and returns the next byte from the current frame and moves the read offset forward. If read offset is already at the end current output frame, this method returns zero.</p>
<dl class="section return"><dt>Returns</dt><dd>The next byte from the current output frame or zero if frame has ended. </dd></dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_af8004f00f97e629cf5c5b0c6d695fcdc_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_af8004f00f97e629cf5c5b0c6d695fcdc_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_af8004f00f97e629cf5c5b0c6d695fcdc_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_af8004f00f97e629cf5c5b0c6d695fcdc_icgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a4062341057541242068c5680c35f5a1c" title="This method reads bytes from the current output frame. " alt="" coords="231,5,399,44"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,68,408,107"/>
<area shape="rect" id="node3" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="456,5,636,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ab8a97ac52ae66b96155e6fb72cbd7e38"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpFrameBuffer::OutFrameRemove </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method removes the current/front output frame from the buffer. </p>
<p>The NCP buffer stores the frames in FIFO order. This method removes the front frame (which may be the current output frame being read) from the buffer. There is no need to prepare/begin reading the current frame before removing it, so the front frame can be removed without a previous call to <code><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af7e6c123cca21c4ea9459c2a3ca350b6" title="This method begins/prepares a new output frame to be read from the frame buffer. ">OutFrameBegin()</a></code>.</p>
<p>When a frame is removed all its associated messages will be freed.</p>
<p>If the remove operation causes the buffer to become empty this method will invoke the <code>EmptyBufferCallback</code>.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully removed the front frame. </td></tr>
    <tr><td class="paramname">kThreadError_NotFound</td><td>No frame available in NCP frame buffer to remove. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_cgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404" title="This method checks if the buffer is empty. " alt="" coords="222,61,390,100"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="447,5,612,44"/>
<area shape="rect" id="node7" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="224,124,389,163"/>
<area shape="rect" id="node8" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="226,187,386,212"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a89b66912022440cb19aa5eefef093b46" title="This method returns a pointer to the next message in the same interface list. " alt="" coords="438,68,620,93"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="447,117,611,143"/>
<area shape="rect" id="node6" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="668,117,866,143"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_ab8a97ac52ae66b96155e6fb72cbd7e38_icgraph">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed" title="This method finalizes and sends the current outbound frame. " alt="" coords="225,5,405,44"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="222,68,408,107"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a69de51cb5b7132fa7d82270f3090f4dc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::NcpFrameBuffer::SetCallbacks </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>&#160;</td>
          <td class="paramname"><em>aEmptyBufferCallback</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>&#160;</td>
          <td class="paramname"><em>aNonEmptyBufferCallback</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aContext</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sets the callbacks and context. </p>
<p>Subsequent calls to this method will overwrite the previous callbacks and context.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aEmptyBufferCallback</td><td>Callback invoked when buffer become empty. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aNonEmptyBufferCallback</td><td>Callback invoked when buffer transition from empty to non-empty. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aContex</td><td>A pointer to arbitrary context information.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Nothing (void). </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_cgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_cgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_cgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_cgraph">
<area shape="rect" id="node2" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="222,5,387,44"/>
<area shape="rect" id="node3" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="222,68,387,107"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="224,131,384,156"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_icgraph.png" border="0" usemap="#d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_icgraph" alt=""/></div>
<map name="d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_icgraph" id="d0/d78/classThread_1_1NcpFrameBuffer_a69de51cb5b7132fa7d82270f3090f4dc_icgraph">
<area shape="rect" id="node2" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb" title="This constructor creates an NCP frame buffer. " alt="" coords="226,5,394,44"/>
<area shape="rect" id="node3" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2" title="This destructor clears the NCP frame buffer and clears all frames. " alt="" coords="226,68,394,107"/>
<area shape="rect" id="node4" href="../../d0/d2a/classThread_1_1NcpSpi.html#a755449adff7ec14f4985ac462c7914bd" title="Constructor. " alt="" coords="228,131,392,156"/>
<area shape="rect" id="node5" href="../../dc/d60/classThread_1_1NcpUart.html#abdc6252f8097fc29b2569b52d0bd43ed" title="Constructor. " alt="" coords="222,180,398,205"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/ncp/<a class="el" href="../../d6/d92/ncp__buffer_8hpp_source.html">ncp_buffer.hpp</a></li>
<li>src/ncp/<a class="el" href="../../d6/dd2/ncp__buffer_8cpp.html">ncp_buffer.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
